workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS
      when: never
    - if: $CI_COMMIT_BRANCH

include:
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: License-Scanning.gitlab-ci.yml
  - template: SAST.gitlab-ci.yml
  - template: Secret-Detection.gitlab-ci.yml

variables:
    SONAR_USER_HOME: '${CI_PROJECT_DIR}/.sonar' # Defines the location of the analysis task cache
    GIT_DEPTH: '0' # Tells git to fetch all the branches of the project, required by the analysis task

stages:
    - test
    - build
    - deploy

build-testnet:
    stage: build
    image: node:16.18.0-alpine3.16
    script:
        - npm install
        - npm run build
        - cd .. && tar czf tradehands-qa.tar.gz trade-hands/
        - cp tradehands-qa.tar.gz trade-hands/ && cd trade-hands
    rules:
    - if: $CI_COMMIT_BRANCH == "develop" || $CI_COMMIT_BRANCH =~ /^release/ || $CI_COMMIT_BRANCH =~ /^hot-fix/ 
    artifacts: 
        paths:
            - tradehands-qa.tar.gz

deploy-to-qa:
    stage: deploy
    dependencies: [build-testnet]
    script:
        - rm -rf $QA_DEPLOY_DIR/* || true
        - tar -zxf tradehands-qa.tar.gz --directory $QA_DEPLOY_DIR
        - cd $QA_DEPLOY_DIR && cd trade-hands
        - pm2 del tradehands-qa || true 
        - pm2 start npm --name tradehands-qa -- run preview
    rules:
        - if: $CI_COMMIT_BRANCH == "develop" || $CI_COMMIT_BRANCH =~ /^release/ || $CI_COMMIT_BRANCH =~ /^hot-fix/ 
    environment:
        name: QA
        url: https://tradehands-qa.peerplays.download
    when: manual
    tags:
        - qa-deployment
        
sonarcloud-check:
    stage: test
    image:
        name: sonarsource/sonar-scanner-cli:latest
        entrypoint: ['']
    cache:
        key: '${CI_JOB_NAME}'
        paths:
            - .sonar/cache
    script:
        - sonar-scanner
    only:
        - merge_requests
        - branches
    tags:
        - sonar-scanner
